const Cc = Components.classes;
const Ci = Components.interfaces;

var nsISocketTransportService =
      Cc["@mozilla.org/network/socket-transport-service;1"].
        getService(Ci.nsISocketTransportService);
var nsIScriptableInputStream =
      Cc["@mozilla.org/scriptableinputstream;1"].
        createInstance(Ci.nsIScriptableInputStream);
var nsIInputStreamPump =
      Cc["@mozilla.org/network/input-stream-pump;1"].
        createInstance(Ci.nsIInputStreamPump);

var nsIConverterInputStream =
      Cc["@mozilla.org/intl/converter-input-stream;1"].
        createInstance(Ci.nsIConverterInputStream);

var nsIConverterOutputStream =
      Cc["@mozilla.org/intl/converter-output-stream;1"].
        createInstance(Ci.nsIConverterOutputStream);
var FireBBS = {
  cursor : null,
  output_area : null,
  toolbar : null,
  outputStream : null,
  inputStream : null,
  HTMLString_cache : '',

  dataListener : {
      data : {},
      restStr : '',

      onStartRequest: function(request, context){
showMSG('start request<br>');
      },

      onStopRequest: function(request, context, status){
        FireBBS.outputStream.close();
        FireBBS.inputStream.close();
        nsIConverterInputStream.close();
        nsIConverterOutputStream.close();
        setTimeout('document.location.reload()', 5000)
showMSG('stop request<br>');

      },

      onDataAvailable: function(request, context, inputStream, offset, count){
var t1 = new Date();
        nsIConverterInputStream.readString(0xFFFF, this.data);
        var str = this.restStr + this.data.value;
        this.restStr ='';
        
if(0){//show unicode number
s=''
for(var i=0; i<str.length;i++){
s += (str.charCodeAt(i)).toString(16) + ', ';
}
showMSG(s+'<br>')
}


if(0){//show raw string
var tmp = str.replace(/\x1B\x5B/g, '&lt;CSI&gt;');
tmp = tmp.replace(/\x1B/g, '&lt;ESC&gt;');
document.getElementById('rawData_area').innerHTML = tmp;
alert(tmp)
}
        str = str.replace(/\x07/g, '\x1B\x07');//escape BEL
        str = str.replace(/[\b]/g, '\x1B[1D');//escape BS(replace )
        str = str.replace(/\t/g, '\x1B[8C');//escape HT(replace )
        str = str.replace(/\n/g, '\x1B\n');//escape LF
        str = str.replace(/\v/g, '\x1B[6B');//escape VT(replace )
        str = str.replace(/\f/g, '\x1B[2J\x1B[H');//escape FF(replace )
        str = str.replace(/\r/g, '\x1B[1G');//escape CR(replace )

        var strArray = str.split('\x1B');
        FireBBS.HTMLString_cache += generate_div(strArray[0]);

        for(var i = 1; i < strArray.length; i++){
         switch(strArray[i][0]){
          case '[' ://Functions using CSI
            var template = /^\x5B((?:|\d+|;)+)([\x40-\x5A\x60-\x7C])/;//Functions using CSI
            var result = template.exec(strArray[i]);

            if(result){
              CSIFunctionHandler(result[2], result[1].split(';'));
              FireBBS.HTMLString_cache += generate_div(strArray[i].substr(result[0].length));
            }
            else{
              if(i == strArray.length - 1){//this is an unfinished data message
                this.restStr = '\x1B' + strArray[i];
                }
              else{
showMSG('unidentified function using CSI in section' + i + ' : ' +
        strArray[i].replace(/^\x5B/, '&lt;CSI&gt;') + '<br>');
              }
            }
            break;

          case '\x07':
            BEL();
            FireBBS.HTMLString_cache += generate_div(strArray[i].substr(1));
            break;
          case '\n':
            LF();
            FireBBS.HTMLString_cache += generate_div(strArray[i].substr(1));
            break;

          case 'D':
            IND();
            FireBBS.HTMLString_cache += generate_div(strArray[i].substr(1));
            break;
          case 'M':
            RI();
            FireBBS.HTMLString_cache += generate_div(strArray[i].substr(1));
            break;
          case 'E':
            NEL()
            FireBBS.HTMLString_cache += generate_div(strArray[i].substr(1));
            break;
          case '7':
            DECSC();
            FireBBS.HTMLString_cache += generate_div(strArray[i].substr(1));
            break;
          case '8':
            DECRC();
            FireBBS.HTMLString_cache += generate_div(strArray[i].substr(1));
            break;
          default:
            if(i == strArray.length - 1){//this is an unfinished data message
              this.restStr = '\x1B' + strArray[i];
            }
            else{
showMSG('unidentified controls beginning with ESC in section' + i + ' : &lt;ESC&gt;' + strArray[i] + '<br>');
            }
          }
        }

        $garbage_div_collector.clearScreen();
        FireBBS.output_area.innerHTML += FireBBS.HTMLString_cache;
        FireBBS.HTMLString_cache = '';
        FireBBS.changeToolBar();
        FireBBS.relocateCursor();
var t2 = new Date();
document.getElementById('time').innerHTML = 'Loading time : ' + (t2-t1) + 'ms';
document.getElementById('divCount').innerHTML = 'Numbers of div : ' + FireBBS.output_area.childNodes.length;
      },
  },

  init : function(){
    var transport = nsISocketTransportService.
          createTransport(null, 0,
                          document.location.hostname, document.location.port ? document.location.port : 23,
                          null);
    var options = document.location.search;
    var charset = (/charset\x3D(\w+)/.exec(options))
                ? (/charset\x3D(\w+)/.exec(options))[1]
                : 'Big5';
    var fontSize = /fontsize\x3D(\d+)/.exec(options);
    var fontFamily = /fontfamily\x3D((?:%|\w)+)/.exec(options);
    var terminal_display_class;
    
    for(var i=0; i<document.styleSheets[0].cssRules.length; i++){
      if(document.styleSheets[0].cssRules[i].selectorText == '.terminal_display'){
        terminal_display_class = document.styleSheets[0].cssRules[i];
      }
    }
      
      
      
      
    const REPLACEMENT_CHARACTER = Ci.nsIConverterInputStream.DEFAULT_REPLACEMENT_CHARACTER;

    this.outputStream = transport.openOutputStream(0,0,0);
    this.inputStream = transport.openInputStream(0,0,0);
    nsIConverterInputStream.init(this.inputStream, charset, 0xFFFF, REPLACEMENT_CHARACTER);
    nsIConverterOutputStream.init(this.outputStream, charset, 0xFFFF, REPLACEMENT_CHARACTER)



    nsIScriptableInputStream.init(this.inputStream);

    nsIInputStreamPump.init(this.inputStream, -1, -1, 0, 0, false);
    nsIInputStreamPump.asyncRead(this.dataListener,null);

    this.cursor = document.getElementById('cursor');
    this.output_area = document.getElementById('output_area');
    this.toolbar = document.getElementById('toolbar');
    
    document.title = document.location.host;
    $garbage_div_collector.initCoveredArea();

    if(fontFamily){
      terminal_display_class.style.fontFamily = decodeURIComponent(fontFamily[1]) + ',monospace';
    }

    if(fontSize){
      terminal_display_class.style.fontSize = fontSize[1] + 'px';
      terminal_display_class.style.lineHeight = fontSize[1] + 'px';
      $character.init(parseInt(fontSize[1]));
      this.output_area.style.width = $character.fontWidth * $output_area.cols + 'px';
      this.output_area.style.height = $character.fontHeight * $output_area.rows + 'px';
    }
  },

  sendData : function(str){
    nsIConverterOutputStream.writeString(str);
    FireBBS.cursor.style.color = 'red';

  },

  relocateCursor : function(){
    var pos = convertMN2XY($cursor.position);
    this.cursor.style.left = pos[0] + 'px';
    this.cursor.style.top = pos[1] + 'px';
    FireBBS.cursor.style.color = '';
  },
  changeToolBar : function(){
    switch(document.location.hostname){
      case 'ptt.cc':
        PTT_toolbar();
        break;
      default:
    }

  },
};